/*
 * AddEditWorld.java
 *
 * Created on April 9, 2006, 4:57 PM
 */

package anecho.JamochaMUD;

import anecho.gui.EasyIconTreeNode;
import anecho.gui.EasyTreeIconRenderer;
import java.util.Enumeration;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreePath;

/**
 * AddEditWorld is a class that displays saved worlds and characters
 * in a tree format.  It allows for editing of this information and
 * connection to the different worlds.  This class is a replacement
 * for the older MuckConn class.
 * $Id: AddEditWorld.java,v 1.8 2006/07/29 16:30:14 jeffnik Exp $
 * @author J. Robinson
 */
public class AddEditWorld extends javax.swing.JDialog {
    
    /** Creates new form AddEditWorld */
    public AddEditWorld() {
        super(JMConfig.getInstance().getJMFrame(JMConfig.MUCKMAINFRAME), true);
        
        initComponents();
        
        java.awt.Point tPoint = anecho.gui.PosTools.findCenter();
        java.awt.Dimension tSize = this.size();
        this.setLocation(tPoint.x - (int)(tSize.width/2) , tPoint.y - (int)(tSize.height/2));
        
        readWorlds();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        worldTreePanel = new javax.swing.JPanel();
        worldScrollPane = new javax.swing.JScrollPane();
        optionRoot = new DefaultMutableTreeNode("Worlds");
        treeModel = new DefaultTreeModel(optionRoot);

        worldTree = new javax.swing.JTree(optionRoot);
        buildTree();
        // EasyTreeIconRenderer renderer = (EasyTreeIconRenderer)worldTree.getCellRenderer();
        EasyTreeIconRenderer renderer = new EasyTreeIconRenderer();
        worldTree.setCellRenderer(renderer);
        //renderer.addIcon("Test",new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //DefaultTreeCellRenderer renderer = (DefaultTreeCellRenderer)worldTree.getCellRenderer();
        //UIManager.put("Tree.leafIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //UIManager.put("Tree.openIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //UIManager.put("Tree.closedIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));

        addB = new javax.swing.JButton();
        delB = new javax.swing.JButton();
        buttonPanel = new javax.swing.JPanel();
        connB = new javax.swing.JButton();
        saveConnB = new javax.swing.JButton();
        saveB = new javax.swing.JButton();
        cancelB = new javax.swing.JButton();
        infoPanel = new javax.swing.JPanel();
        worldPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        muNotesTA = new javax.swing.JTextArea();
        autoLoginCB = new javax.swing.JCheckBox();
        loginL = new javax.swing.JLabel();
        loginStyleCB = new anecho.gui.JMappedComboBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        mNameTF = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        mAddressTF = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        mPortTF = new javax.swing.JTextField();
        sslCB = new javax.swing.JCheckBox();
        charPanel = new javax.swing.JPanel();
        charNotesL = new javax.swing.JLabel();
        charNotes = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        namePWPanel = new javax.swing.JPanel();
        nameL = new javax.swing.JLabel();
        charName = new javax.swing.JTextField();
        passwordL = new javax.swing.JLabel();
        charPassword = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("JamochaMUD MU* Connector");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        worldTreePanel.setLayout(new java.awt.GridBagLayout());

        worldTree.setToolTipText("A list of your current MU*s.  The ability to add character is not complete at this time.");
        worldTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                worldTreeMouseClicked(evt);
            }
        });

        worldScrollPane.setViewportView(worldTree);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weighty = 0.9;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(worldScrollPane, gridBagConstraints);

        addB.setText("Add");
        addB.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                addBMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(addB, gridBagConstraints);

        delB.setText("Delete");
        delB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                delBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(delB, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 0.6;
        gridBagConstraints.weighty = 0.9;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 3);
        getContentPane().add(worldTreePanel, gridBagConstraints);

        connB.setText("Connect Only");
        connB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connBActionPerformed(evt);
            }
        });

        buttonPanel.add(connB);

        saveConnB.setText("Save & Connect");
        saveConnB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveConnBActionPerformed(evt);
            }
        });

        buttonPanel.add(saveConnB);

        saveB.setText("Save");
        saveB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveBActionPerformed(evt);
            }
        });

        buttonPanel.add(saveB);

        cancelB.setText("Don't connect");
        cancelB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBActionPerformed(evt);
            }
        });

        buttonPanel.add(cancelB);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(7, 5, 5, 5);
        getContentPane().add(buttonPanel, gridBagConstraints);

        infoPanel.setLayout(new java.awt.CardLayout());

        worldPanel.setLayout(new java.awt.GridBagLayout());

        muNotesTA.setColumns(20);
        muNotesTA.setRows(5);
        jScrollPane1.setViewportView(muNotesTA);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 3, 3);
        worldPanel.add(jScrollPane1, gridBagConstraints);

        autoLoginCB.setText("Auto-login");
        autoLoginCB.setToolTipText("<html>\nAllow JamochaMUD to automatically<br>\nlog your character in using the provided<br>\ncharacter name and password.<br>\nIf a custom login script is provided it<br>\nwill be used as the login style.\n</html>");
        autoLoginCB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        autoLoginCB.setEnabled(false);
        autoLoginCB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        autoLoginCB.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                autoLoginCBStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(autoLoginCB, gridBagConstraints);

        loginL.setText("Login style");
        loginL.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(loginL, gridBagConstraints);

        loginStyleCB.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Custom connection script" }));
        loginStyleCB.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(loginStyleCB, gridBagConstraints);

        jLabel4.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(7, 3, 7, 3);
        worldPanel.add(jLabel4, gridBagConstraints);

        jLabel1.setText("MU* Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldPanel.add(jLabel1, gridBagConstraints);

        mNameTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(mNameTF, gridBagConstraints);

        jLabel2.setText("MU* Address");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldPanel.add(jLabel2, gridBagConstraints);

        mAddressTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 3, 3);
        worldPanel.add(mAddressTF, gridBagConstraints);

        jLabel3.setText("MU* Port");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldPanel.add(jLabel3, gridBagConstraints);

        mPortTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(mPortTF, gridBagConstraints);

        sslCB.setText("Secure Connection (SSL)");
        sslCB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        sslCB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 7, 3);
        worldPanel.add(sslCB, gridBagConstraints);

        infoPanel.add(worldPanel, "card2");

        charPanel.setLayout(new java.awt.GridBagLayout());

        charNotesL.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        charPanel.add(charNotesL, gridBagConstraints);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        charNotes.setViewportView(jTextArea1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        charPanel.add(charNotes, gridBagConstraints);

        namePWPanel.setLayout(new java.awt.GridBagLayout());

        nameL.setText("Character name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 3);
        namePWPanel.add(nameL, gridBagConstraints);

        charName.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        namePWPanel.add(charName, gridBagConstraints);

        passwordL.setText("Password");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 3);
        namePWPanel.add(passwordL, gridBagConstraints);

        charPassword.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        namePWPanel.add(charPassword, gridBagConstraints);

        jLabel5.setText("Connection string");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 3);
        namePWPanel.add(jLabel5, gridBagConstraints);

        jTextField1.setToolTipText("<html>\nAdvanced users may wish to use this area to create a custom<br>\nlogin or to have additional actions performed upon login.<br>\nLeave blank if you don't wish to have a custom login.\n</html>");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        namePWPanel.add(jTextField1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        charPanel.add(namePWPanel, gridBagConstraints);

        infoPanel.add(charPanel, "card3");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 0.4;
        gridBagConstraints.weighty = 0.9;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 5);
        getContentPane().add(infoPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void saveConnBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveConnBActionPerformed
        saveInfo();
        connectToMU();
    }//GEN-LAST:event_saveConnBActionPerformed
    
    private void delBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_delBActionPerformed
        deleteTreeItem();
    }//GEN-LAST:event_delBActionPerformed
    
    private void connBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connBActionPerformed
        connectToMU();
    }//GEN-LAST:event_connBActionPerformed
    
    private void saveBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveBActionPerformed
        saveInfo();
    }//GEN-LAST:event_saveBActionPerformed
    
    private void addBMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_addBMouseClicked
        addTreeItem(evt);
    }//GEN-LAST:event_addBMouseClicked
    
    private void worldTreeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_worldTreeMouseClicked
        updateInfo();
        
        // If we have a double-click, connect to the given MU*
        if (evt.getClickCount() > 1) {
            connectToMU();
        }
        
    }//GEN-LAST:event_worldTreeMouseClicked
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        // If there are no worlds open already, we should terminate JamochaMUD
        JMConfig settings = JMConfig.getInstance();
        CHandler chandle = settings.getConnectionHandler();
        
        if (chandle.totalConnections() < 1) {
            if (DEBUG) {
                System.err.println("AddEditWorld.formWindowClosed is terminating JamochaMUD.");
            }
            System.exit(0);
        }

        dontConnect();
    }//GEN-LAST:event_formWindowClosed
    
    private void cancelBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBActionPerformed
        dontConnect();
    }//GEN-LAST:event_cancelBActionPerformed
    
    private void autoLoginCBStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_autoLoginCBStateChanged
        enableLoginStyle(autoLoginCB.isSelected());
    }//GEN-LAST:event_autoLoginCBStateChanged
    
    /** Connect to the currently selected world */
    private void connectToMU() {
        // Get the selected node
        World tempWorld;
        Object tempNode = worldTree.getLastSelectedPathComponent();
        
        // Determine if the node is a world or character
        try {
            tempWorld = (World)tempNode;
            if (DEBUG) {
                System.err.println("Attempting connection to world: " + tempWorld.getWorldName());
            }
        } catch (Exception castExc) {
            if (DEBUG) {
                System.err.println("Will make connection to world using character " + tempNode);
            }
            return;
        }
        
        currentWorld = tempWorld;
        hideConnector();
    }
    
    /** Add either a new world or new character to our JTree */
    private void addTreeItem(java.awt.event.MouseEvent evt) {
        // Right now we'll just add a world by default.  Fix Me XXX
        World tempWorld = new World();

        tempWorld.setWorldName("Nothing");
        tempWorld.setAddress("No address");
        tempWorld.setPort(0);
        int len = optionRoot.getChildCount();

        if (DEBUG) {
            System.err.println("We have " + len + " children on our tree");
        }

        treeModel.insertNodeInto(tempWorld, optionRoot, optionRoot.getChildCount());
        worldTree.updateUI();
        
        if (DEBUG) {
            System.err.println("After insertion we have " + optionRoot.getChildCount() + " children.");
        }
        
        // Select the newly created world, and then move focus to our editing area
        TreePath treePath = new TreePath(treeModel.getPathToRoot(tempWorld));
        worldTree.setSelectionPath(treePath);
        updateInfo();

    }
    
    /** Delete the currently selected item from the Tree */
    private void deleteTreeItem() {
        TreePath tPath = worldTree.getSelectionPath();
        
        if (tPath == null) {
            // There is currently no selected node on the JTree
            return;
        }
        
        TreePath currentSelection = worldTree.getSelectionPath();
        if (currentSelection != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
            (currentSelection.getLastPathComponent());
            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent != null) {
                if (DEBUG) {
                    System.err.println("AddEditWorld.deleteTreeItem() Removing node.");
                }
                treeModel.removeNodeFromParent(currentNode);
                // Get the path of the world above this one
                // (currentNode.getPreviousLeaf()).getPath();
                // DefaultMutableTreeNode prevNode = currentNode.getPreviousLeaf();
                
                // worldTree.setSelectionPath(currentNode.getPreviousLeaf().getPath());
            } else {
                if (DEBUG) {
                    System.err.println("AddEditWorld.deleteTreeItem() has no parent");
                }
            }
        } else {
            if (DEBUG) {
                System.err.println("AddEditWorld.deleteTreeItem() has no current selection.");
            }
        }
        
        worldTree.updateUI();
        
        // Select next applicable node
        updateInfo();
        
        
    }
    
    private void dontConnect() {
        currentWorld.setWorldName(null);

        hideConnector();
        
    }
    
    private void hideConnector() {
        setVisible(false);
        JMConfig settings = JMConfig.getInstance();
        
        final java.awt.Frame mmFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);
        if (!mmFrame.isVisible()) {
            mmFrame.setVisible(true);
        }
        
        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);
        
        // Send the focus to our main program... just a nice thing to do
        mmFrame.requestFocus();
        
        writeWorlds();
        
    }
    
    private void readWorlds() {
        final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(anecho.JamochaMUD.JMUD.class);
        
        // Try to read our list of worlds
        int wc = prefs.getInt(WORLDCOUNT, 0);
        int cc = prefs.getInt(CHARCOUNT, 0);
        
        if (wc < 1) {
            // We have no worlds, and can therefore not have any characters
            if (DEBUG) {
                System.err.println("AddEditWorld.readWorlds: No worlds to read.");
            }
            
            // If we have no worlds, try to import old worlds instead
            importOldWorlds();
            
            return;
        }
        
        World tempWorld;
        
        for (int i = 0; i < wc; i++) {
            tempWorld = new World();
            
            tempWorld.setWorldName(prefs.get(this.WORLDNAME + "_" + i, "No name"));
            tempWorld.setAddress(prefs.get(this.WORLDADDRESS + "_" + i, "no address"));
            tempWorld.setPort(prefs.getInt(this.WORLDPORT + "_" + i, 0));
            tempWorld.useSSL(prefs.getBoolean(this.WORLDSSL + "_" + i, false));
            tempWorld.setLoginStyle(prefs.getInt(this.WORLDAUTOLOGIN + "_" + i, NO_AUTOLOGIN));
            tempWorld.setNotes(prefs.get(this.WORLDNOTES + "_" + i, ""));
            
            if (tempWorld.getLoginStyle() != NO_AUTOLOGIN) {
                tempWorld.useSSL(true);
            }
            
            // Insert this new world into our vector
            treeModel.insertNodeInto(tempWorld, optionRoot, optionRoot.getChildCount());
            
        }
        
        // Collect our character information
        if (cc < 1) {
            // No characters available
            if (DEBUG) {
                System.err.println("AddEditWorld.readWorld: no characters available");
            }
            
            // May cause an error.  Fix this XXX
            // return;
            
        }
        
        MUChar tempChar;
        
        for (int i =0; i < cc; i++) {
            tempChar = new MUChar();
            
            tempChar.setName(prefs.get(this.CHARACTERNAME + "_" + i, "No name"));
            tempChar.setPassword(prefs.get(this.CHARACTERPASSWORD + "_" + i, ""));
            tempChar.setConnString(prefs.get(this.CHARACTERCONNSTR + "_" + i, ""));
            tempChar.setNotes(prefs.get(this.CHARACTERNOTES + "_" + i, ""));
            tempChar.setWorldID(prefs.getLong(this.CHARWORLDID + "_" + i, 0));
        }
        
        // Update the tree view to show all our info
        worldTree.expandRow(0);
        worldTree.updateUI();

        int treeCount = worldTree.getRowCount();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.readWorlds: worldTree.getRowCount returns " + treeCount + " rows.");
        }
        
        for (int i = 0; i < treeCount; i++) {
            worldTree.expandRow(i);
        }

        
    }
    
    private void writeWorlds() {
        final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(anecho.JamochaMUD.JMUD.class);
        
        if (DEBUG) {
            System.err.println("Iterating through tree to find worlds");
        }
        
        World tempWorld;
        // DefaultMutableTreeNode tempNode;
        
        int worlds = 0 ;
        
        if (DEBUG) {
            System.err.println("We have " + optionRoot.getChildCount() + " worlds in our tree.");
        }
        
        Enumeration e = optionRoot.children();
        
        while (e.hasMoreElements()) {
            try {
                tempWorld = (World)e.nextElement();
                
                // Write out the world
                prefs.put(this.WORLDNAME + "_" + worlds, tempWorld.getWorldName());
                prefs.put(this.WORLDADDRESS + "_" + worlds, tempWorld.getAddress());
                prefs.putInt(this.WORLDPORT + "_" + worlds, tempWorld.getPort());
                prefs.putBoolean(this.WORLDSSL + "_" + worlds, tempWorld.isSSL());
                prefs.putInt(this.WORLDAUTOLOGIN + "_" + worlds, tempWorld.getLoginStyle());
                prefs.put(this.WORLDNOTES + "_" + worlds, tempWorld.getNotes());
                worlds++;
                
            } catch (Exception worldExc) {
                if (DEBUG) {
                    System.err.println("writeWorlds() couldn't cast element properly " + worldExc);
                    worldExc.printStackTrace();
                }
                
            }
            
        }
        
        prefs.putInt(WORLDCOUNT, worlds);
        
    }
    
    /** Add all the nodes to our JTree of options */
    private void buildTree() {
        // DefaultMutableTreeNode tempNode;
        // World tempWorld;
        
//        try {
////            int wc = worlds.size();
////            for (int i = 0; i < wc; i++) {
////                tempWorld = (World)worlds.elementAt(i);
////                treeModel.insertNodeInto(tempWorld, optionRoot, optionRoot.getChildCount());
////            }
//        } catch (Exception exc) {
//            if (DEBUG) {
//                System.err.println("AddEditWorld.buildTree exception adding worlds or characters " + exc);
//            }
//        }
        
    }
    
    /** Enables or disables our auto-login style */
    private void enableLoginStyle(boolean state) {
        loginL.setEnabled(state);
        loginStyleCB.setEnabled(state);
    }
    
    /**
     * Return the name of the currently selected world
     * @return Returns a string of containing the currently selected
     * World's name.
     */
    public String getName() {
        String retStr = "nothing";
        
        if (currentWorld != null) {
            retStr = currentWorld.getWorldName();
        }
        
        return retStr;
    }
    
    /**
     * Return the address of the currently selected World.
     * @return The address of the currently selected World.
     */
    public String getAddress() {
        String retStr = "nothing";
        
        if (currentWorld != null) {
            retStr = currentWorld.getAddress();
        }
        return retStr;
    }
    
    /**
     * Returns the port number of the currently selected World.
     * @return Returns the port number of the currently selected World.
     */
    public int getPort() {
        int retPort = -1;
        if (currentWorld != null) {
            retPort = currentWorld.getPort();
        }
        return retPort;
    }
    
    /**
     * Returns whether the currently selected world uses a secure (SSL)
     * connection.
     * @return <CODE>true</CODE> - this world uses a secure (SSL) connection
     * <CODE>false</CODE> - this world sends data unencrypted
     */
    public boolean getSSL() {
        boolean retSSL = false;
        if (currentWorld != null) {
            retSSL = currentWorld.isSSL();
        }
        return retSSL;
    }
    
    private void updateInfo() {
        // Update the shown info based on the item selected in the World JTree
        
        // Get the selected node
        Object tempNode = worldTree.getLastSelectedPathComponent();
        int selCount = worldTree.getSelectionCount();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.updateInfo(): Selection count is: " + selCount);
        }
        // Determine if the node is a world or character
        try {
            World tempWorld = (World)tempNode;
            if (DEBUG) {
                System.err.println("We have cast this to World: " + tempWorld.getWorldName());
            }
            updateWorldForm(tempWorld);
        } catch (Exception castExc) {
            if (DEBUG) {
                System.err.println("Error casting " + tempNode + " to a world.");
            }
        }
        
    }
    
    private void updateWorldForm(World selWorld) {
        mNameTF.setText(selWorld.getWorldName());
        mAddressTF.setText(selWorld.getAddress());
        mPortTF.setText(selWorld.getPort() + "");
        sslCB.setSelected(selWorld.isSSL());
        autoLoginCB.setSelected(selWorld.isAutoLogin());
        loginStyleCB.setSelectedIndex(selWorld.getLoginStyle());
        muNotesTA.setText(selWorld.getNotes());
    }
    
    /** Save the current information in our form to our selected node */
    private void saveInfo() {
        // Get the selected node
        Object tempNode = worldTree.getLastSelectedPathComponent();
        
        // Determine if the node is a world or character
        try {
            World tempWorld = (World)tempNode;
            if (DEBUG) {
                System.err.println("saveInfo has cast this to World: " + tempWorld.getWorldName());
            }
            saveWorldInfo(tempWorld);
        } catch (Exception castExc) {
            if (DEBUG) {
                System.err.println("saveInfo Error casting " + tempNode + " to a world.");
            }
        }
        
    }
    
    /** Update the world object in our JTree with the information from the TextFields */
    private void saveWorldInfo(World selWorld) {
        selWorld.setWorldName(mNameTF.getText());
        selWorld.setAddress(mAddressTF.getText());
        selWorld.setPort(Integer.parseInt(mPortTF.getText()));
        selWorld.useSSL(sslCB.isSelected());
        selWorld.useAutoLogin(autoLoginCB.isSelected());
        selWorld.setLoginStyle(loginStyleCB.getSelectedIndex());
        selWorld.setNotes(muNotesTA.getText());
        
        // Update the JTree view
        worldTree.updateUI();
        
        if (DEBUG) {
            System.err.println("Saved world information");
        }
    }
    
    /** Import worlds from the format previously used by JamochaMUD */
    private void importOldWorlds() {
        Vector muckList = new java.util.Vector(0, 1);
        JMConfig settings = JMConfig.getInstance();
        muckList = settings.getJMVector(JMConfig.MUCKLIST);
        
        if (DEBUG) {
            System.err.println("AddEditWorld.importOldWorlds() attempting to import old-style MU settings");
        }
        
        World tempWorld;
        MuckInfo tempMU;
        
        int listSize = muckList.size();
        
        // Check to see if there are worlds to import
        if (listSize > 0) {
            // There are worlds to possibly import.  We should ask the user first
            int n = JOptionPane.showConfirmDialog(this,
                    "Would you like to import your existing worlds\ninto this version of JamochaMUD?",
                    "Import existing worlds?",
                    JOptionPane.YES_NO_OPTION);
            
            if (n == JOptionPane.NO_OPTION) {
                return;
            }
        } else {
            // Is this return necessary?  Fix Me XXX
            return;
        }
        
        for (int i = 0; i < listSize; i++) {
            tempMU = (MuckInfo)muckList.elementAt(i);
            tempWorld = new World();
            
            tempWorld.setWorldName(tempMU.getName());
            tempWorld.setAddress(tempMU.getAddress());
            tempWorld.setPort(tempMU.getPort());
            tempWorld.useSSL(tempMU.getSSL());
            
            // Insert the new world into our JTree
            treeModel.insertNodeInto(tempWorld, optionRoot, optionRoot.getChildCount());
            
            if (DEBUG) {
                System.err.println("AddEditWorld.importOldWorlds() importing MU*: " + tempMU.getName());
            }
        }
        
        worldTree.updateUI();
        
    }
    
    /** This private inner class will be used to store World information */
//    private class World extends DefaultMutableTreeNode {
    private class World extends EasyIconTreeNode {
        public World() {
            // Generate a unique WorldID for this instance
            worldID = System.currentTimeMillis();
            if (DEBUG) {
                System.err.println("New worldID set to " + worldID);
            }
            
            // ImageIcon leafIcon = new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png"));
            
            // setIcon(leafIcon);
            
        }
        
        public void setWorldName(String newName) {
            worldName = newName;
        }
        
        public String getWorldName() {
            return worldName;
        }
        
        public void setAddress(String addy) {
            worldAddress = addy;
        }
        
        public String getAddress() {
            return worldAddress;
        }
        
        public void setPort(int port) {
            worldPort = port;
        }
        
        public int getPort() {
            return worldPort;
        }
        
        /** Returns an ID unique to this world.  The ID is generated by
         * this class upon creation of a new world, and cannot be altered.
         * This should help avoid "book-keeping" headaches.
         */
        public long getWorldID() {
            return worldID;
        }
        
        public void useSSL(boolean state) {
            worldSSL = state;
        }
        
        public boolean isSSL() {
            return worldSSL;
        }
        
        public void useAutoLogin(boolean state) {
            worldAutoLogin = state;
        }
        
        public boolean isAutoLogin() {
            return worldAutoLogin;
        }
        
        public void setLoginStyle(int style) {
            worldLoginStyle = style;
        }
        
        public int getLoginStyle() {
            return worldLoginStyle;
        }
        
        public void setNotes(String notes) {
            worldNotes = notes;
        }
        
        public String getNotes() {
            return worldNotes;
        }
        
        public Icon getIcon() {
            Icon retIcon = new ImageIcon(AddEditWorld.class.getResource("icons/22/browser.png"));
            
            return retIcon;
        }
        
        /** Return a string listing the name, address, and port */
        public String toString() {
            StringBuffer retBuff = new StringBuffer();
            retBuff.append(this.getWorldName());
            retBuff.append(" (");
            retBuff.append(this.getAddress());
            retBuff.append(":");
            retBuff.append(this.getPort());
            retBuff.append(")");
            
            if (DEBUG) {
                System.err.println("World.toString() returns " + retBuff.toString());
            }
            return retBuff.toString();
        }
        
        private String worldName = "";
        private String worldAddress = "";
        private int worldPort = 0;
        private long worldID;
        private boolean worldSSL;
        private boolean worldAutoLogin;
        private int worldLoginStyle;
        private String worldNotes = "";
    }
    
    /** This private inner class will be used to store Character information */
    // private class MUChar extends DefaultMutableTreeNode {
    private class MUChar extends EasyIconTreeNode {
        public MUChar() {
            
        }
        
        public MUChar(String name) {
            charName = name;
        }
        
        public void setName(String name) {
            charName = name;
        }
        
        public String getName() {
            return charName;
        }
        
        public void setPassword(String password) {
            charPassword = password;
        }
        
        public String getPassword() {
            return charPassword;
        }
        
        public void setConnString(String connString) {
            charConn = connString;
        }
        
        public String getConnString() {
            return charConn;
        }
        
        public void setNotes(String notes) {
            charNotes = notes;
        }
        
        public String getNotes() {
            return charNotes;
        }
        
        public void setWorldID(long worldID) {
            charWorldID = worldID;
        }
        
        public long getWorldID() {
            return charWorldID;
        }
        
        private String charName;
        private String charPassword;
        private String charConn;
        private String charNotes;
        private long charWorldID;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addB;
    private javax.swing.JCheckBox autoLoginCB;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelB;
    private javax.swing.JTextField charName;
    private javax.swing.JScrollPane charNotes;
    private javax.swing.JLabel charNotesL;
    private javax.swing.JPanel charPanel;
    private javax.swing.JTextField charPassword;
    private javax.swing.JButton connB;
    private javax.swing.JButton delB;
    private javax.swing.JPanel infoPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JLabel loginL;
    private anecho.gui.JMappedComboBox loginStyleCB;
    private javax.swing.JTextField mAddressTF;
    private javax.swing.JTextField mNameTF;
    private javax.swing.JTextField mPortTF;
    private javax.swing.JTextArea muNotesTA;
    private javax.swing.JLabel nameL;
    private javax.swing.JPanel namePWPanel;
    private javax.swing.JLabel passwordL;
    private javax.swing.JButton saveB;
    private javax.swing.JButton saveConnB;
    private javax.swing.JCheckBox sslCB;
    private javax.swing.JPanel worldPanel;
    private javax.swing.JScrollPane worldScrollPane;
    private javax.swing.JTree worldTree;
    private javax.swing.JPanel worldTreePanel;
    // End of variables declaration//GEN-END:variables
    private static final boolean DEBUG = false;
    private static final String WORLDNAME = "JMUD_World_Name";
    private static final String WORLDADDRESS = "JMUD_World_Address";
    private static final String WORLDPORT = "JMUD_World_Port";
    private static final String WORLDSSL = "JMUD_World_SSL";
    private static final String WORLDAUTOLOGIN = "JMUD_World_AutoLogin";
    private static final String WORLDNOTES = "JMUD_World_Notes";
    
    private static final String CHARACTERNAME = "JMUD_Char_Name";
    private static final String CHARACTERPASSWORD = "JMUD_Char_Password";
    private static final String CHARACTERCONNSTR = "JMUD_Char_ConnectionString";
    private static final String CHARACTERNOTES = "JMUD_Char_Notes";
    private static final String CHARWORLDID = "JMUD_Char_WorldID";
    
    private static final String WORLDCOUNT = "WorldCount";
    private static final String CHARCOUNT = "CharacterCount";
    
    private static final int NO_AUTOLOGIN = 0;
    
    private DefaultMutableTreeNode optionRoot;
    private DefaultTreeModel treeModel;
    /**
     * This class contains the world currently selected, which is returned
     * to JamochaMUD if the user chooses to connect.
     */
    World currentWorld = new World();
}
