/*
 * SpellCheck.java
 *
 * Created on March 3, 2006, 11:42 PM
 */

package anecho.JamochaMUD.PrefPanels.SpellCheck;

import anecho.JamochaMUD.JMConfig;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author  jeffnik
 */
public class SpellCheck extends javax.swing.JPanel implements anecho.JamochaMUD.PrefPanels.PrefInterface {
    
    /** Creates new form SpellCheck */
    public SpellCheck() {
        // initComponents();
        if (DEBUG) {
            System.err.println("Creating new SpellCheck instance");
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        addLang = new javax.swing.JButton();
        enableCheck = new javax.swing.JCheckBox();
        langList = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setBackground(javax.swing.UIManager.getDefaults().getColor("InternalFrame.activeTitleBackground"));
        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setText("Spell Check");
        jLabel1.setOpaque(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jLabel1, gridBagConstraints);

        jLabel2.setText("Dictionary file");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jLabel2, gridBagConstraints);

        addLang.setText("Install dictionary");
        addLang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addLangActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(addLang, gridBagConstraints);

        enableCheck.setSelected(true);
        enableCheck.setText("Enable spell check");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(enableCheck, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(langList, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents
    
    private void addLangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addLangActionPerformed
        locateDictionary();
    }//GEN-LAST:event_addLangActionPerformed
    
    public void applySettings() {
        if (DEBUG) {
            System.err.println("SpellCheck.applySettings() has been called.");
        }
        // final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(this.getClass());
        final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(anecho.JamochaMUD.JMUD.class);
        dictFile = langList.getText();
        // final boolean stopFirst = false;
        
        final JMConfig settings = JMConfig.getInstance();
        final anecho.JamochaMUD.DataIn dat = settings.getDataInVariable();
        
        if (!prefs.get(DICTLABEL, "").equals(dictFile)) {
            // The dictionary file has changed so make certain we get rid
            // of the previous instance
            if (DEBUG) {
                System.err.println("Trying to remove previous instance of spellcheck");
            }
            dat.setSpellCheck(false);
        }
        
        prefs.put(DICTLABEL, dictFile);
        
        
        final boolean autoCheck = enableCheck.isSelected();
        prefs.putBoolean(SPELLCHECKLABEL, autoCheck);
        
        
        // Tell any needed components about new spellcheck state
        dat.setSpellCheck(autoCheck);
    }
    
    public JPanel loadPanel() {
        // Check to see if components have already been initialised
        if (langList == null) {
            if (DEBUG) {
                System.err.println("SpellCheck.Loading new panel");
            }
            // Initialise our components
            initComponents();
            
            // Setup the colours in our table
            loadSettings();
        } else {
            if (DEBUG) {
                System.err.println("SpellCheck.Panel already loaded");
            }
        }
        
        return this;
    }
    
    public String getModuleName() {
        final String retStr = "Spell Check";
        return retStr;
    }
    
    private void loadSettings() {
        // final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(this.getClass());
        final java.util.prefs.Preferences prefs = java.util.prefs.Preferences.userNodeForPackage(anecho.JamochaMUD.JMUD.class);
        
        
        dictFile = prefs.get(DICTLABEL, "");
        
        if (dictFile != "") {
            langList.setText(dictFile);
        }
        
        final boolean autoCheck = prefs.getBoolean(SPELLCHECKLABEL, false);
        enableCheck.setSelected(autoCheck);
    }
    
    private void locateDictionary() {
        final JFileChooser chooser = new JFileChooser();
        chooser.setDialogTitle("Please choose a dictionary file");
        chooser.setDialogType(JFileChooser.OPEN_DIALOG);
//        final SimpleFilter filter = new SimpleFilter();
//        filter.setFilters(new String[]{".dic", "*"});
//        filter.setDescription("Aspell dictionary file");
//        chooser.setAcceptAllFileFilterUsed(false);
//        chooser.setFileFilter(filter);
        final int returnVal = chooser.showDialog((JFrame)JMConfig.getInstance().getJMFrame(JMConfig.MUCKMAINFRAME), "Locate dictionary");
        
        if (returnVal == JFileChooser.CANCEL_OPTION) {
            // User has chosen to abort export
            return;
        }
        
        final File selFile = chooser.getSelectedFile();
        langList.setText(selFile.getAbsolutePath());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addLang;
    private javax.swing.JCheckBox enableCheck;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField langList;
    // End of variables declaration//GEN-END:variables
    private static final boolean DEBUG = false;
    private String dictFile;
    
    private static final String DICTLABEL = "DictFile";
    private static final String SPELLCHECKLABEL = "SpellCheckEnabled";
}
