/*
 * EasyTreeIconRenderer.java
 *
 * Created on July 24, 2006, 8:37 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package anecho.gui;

import java.awt.Component;
import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

/**
 * This class is used to display custom icons for individual nodes
 * in a JTree.  It works in conjunction with the EasyIconTreeNode
 * class, but can be used by any tree node.
 * @author jeffnik
 */
public class EasyTreeIconRenderer extends DefaultTreeCellRenderer {
    
    /**
     * 
     * @param tree 
     * @param value 
     * @param sel 
     * @param expanded 
     * @param leaf 
     * @param row 
     * @param hasFocus 
     * @return 
     */
    public Component getTreeCellRendererComponent(JTree tree, Object value,
            boolean sel, boolean expanded, boolean leaf, int row,
            boolean hasFocus) {
        
        
        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
                row, hasFocus);
        
        if (DEBUG) {
            System.err.println("EasyTreeIconRenderer node value: " + value);
        }
        
        // Try to set the icon via the value
        DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode)value;

        // Fix ME XXX
        // This block throws an exception if we execute it, but it seems to do
        // what we want.  If it is commented out, the icons do not change.
        // It's really weird.
        try {
            EasyIconTreeNode tempNode = (EasyIconTreeNode)dmtn;
            Icon tempIcon = tempNode.getIcon();
            setIcon(tempIcon);
        } catch (Exception exc) {
            if (DEBUG) {
                System.err.println("Exception with cast " + exc);
                exc.printStackTrace();
            }
        }
        
        return this;
    }
    
    private static boolean DEBUG = true;
}

