/*
 * JMFancyTabbedPane.java
 *
 * Created on March 30, 2006, 9:16 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package anecho.gui;

import java.awt.Component;
import java.awt.SystemColor;

/**
 *
 * @author J. Robinson
 */
public class JMFancyTabbedPane extends javax.swing.JTabbedPane {
    
    private SystemColor fgColor;
    private SystemColor bgColor;
    
    /** Creates a new instance of JMFancyTabbedPane */
    public JMFancyTabbedPane() {
        super();
    }

    public JMFancyTabbedPane(int tabPlacement) {
        super(tabPlacement);
    }
    
    public JMFancyTabbedPane(int tabPlacement, int tabLayoutPolicy) {
        super(tabPlacement, tabLayoutPolicy);
    }
            
    public void flashTab(Component comp, boolean state) {
        int target = this.indexOfComponent(comp);
        this.flashTab(target, state);
    }
    
    /** Enable or disable tab flashing.
     *  Currently we'll just swap the colours until we can set-up a
     *  proper way to blink them
     */
    public void flashTab(int target, boolean state) {
        
        fgColor = SystemColor.controlText;
        bgColor = SystemColor.control;
        
        if (state)  {
            // Reverse the colours
            if (DEBUG) {
                System.err.println("JMFancyTabbedPane background: " + fgColor);
                System.err.println("JMFancyTabbedPane foreground: " + bgColor);
            }
            this.setBackgroundAt(target, fgColor);
            this.setForegroundAt(target, bgColor);
        } else {
            // Revert the colours to normal
            if (DEBUG) {
                System.err.println("JMFancyTabbedPane background: " + bgColor);
                System.err.println("JMFancyTabbedPane foreground: " + fgColor);
            }
            this.setBackgroundAt(target, bgColor);
            this.setForegroundAt(target, fgColor);
        }
    }
    
    private static final boolean DEBUG = false;
}
